Subject: bug#52981: Flatpak GnuPG install conflicts with existing GnuPG install

From: Leo Famulari <[email-masked]>
Date: Mon, 3 Jan 2022 13:56:02 -0500

On Mon, Jan 03, 2022 at 05:28:17PM +0100, Erik Winkels wrote:
> When doing a `guix install flatpak` while having `gnupg` already installed as a user package I get this error:
> 
> ```
> $ guix package --list-installed
> [...]
> gnupg 2.2.32 out /gnu/store/75122spwjdkxxgd32gkkil3n7ifax8i5-gnupg-2.2.32
> 
> $ guix install flatpak
> The following package will be installed:
> flatpak 1.12.1
> guix install: error: profile contains conflicting entries for gnupg
> guix install: error: first entry: [email-masked] /gnu/store/0snfzd41n430ddpq316j9v2z5fn2y62m-gnupg-2.2.30
> guix install: error: ... propagated from [email-masked]
> guix install: error: second entry: [email-masked] /gnu/store/75122spwjdkxxgd32gkkil3n7ifax8i5-gnupg-2.2.32
> hint: Try upgrading both `flatpak' and `gnupg', or remove one of them from the profile.

Thanks for the report. This is fallout from the fix for
<https://issues.guix.gnu.org/52483>, where GnuPG 2.2.30 was released
with significant bugs and we didn't notice until we'd already deployed
it for users.

Unfortunately, gnupg-2.2.30 has ~2400 dependent packages:

------
$ guix refresh -l [email-masked]
Building the following 1324 packages would ensure 2425 dependent packages are rebuilt: [...]
------

So, we can't upgrade it directly on the master branch.

I'll look into upgrading Flatpak's dependency on GnuPG.

> Worse, initially the Flatpak install did not complain because I had GnuPG installed as a system package. After installing Flatpak `gpg` mostly stopped working with `gpg-agent` segfaulting. It took a while to figure out Flatpak's GnuPG was the culprit.

Oof :(